createIcon = function(name) {
    return {
        width: 100,
        height: 100,
        comps: [
            {
                type: "circle",
                rect: [5, 5, 85, 85],
                borderWidth: 5,
                borderColor: "#3498DB",
                gradient: "radial.northwest"
            },
            {
                type: "text",
                text: name,
                align: "center",
                font: "26px Arial",
                color: "red",
                rect: [5, 5, 85, 85]
            }
        ]
    };
};

palette_config = {
    operation: {
        name: '操作',
        items: [
            { name: '设置父子', image: createIcon('parent'), draggable: false, operation: 'parent' },
            { name: '设置吸附', image: createIcon('host'), draggable: false, operation: 'host' },
            { name: '删除图标', image: createIcon('icon'), draggable: false, operation: 'icon' }
        ]
    },
    node: {
        name: '网元',
        items: [
            { name: '文字', image: 'text', type: ht.Text },
            { name: '开关', image: 'switch', type: ht.Switch},
            { name: '路由器', image: 'images/node/router.png' },
            { name: '电话', image: 'images/node/phone.png' },
            { name: '域名服务器', image: 'images/node/dns.png' },
            { name: '工作组', image: 'images/node/workgroup.png' },
            { name: '节点', image: 'node_image', icon: 'node_icon'},
            { name: '组', image: 'group_image', icon: 'group_icon', type: ht.Group},
            { name: '子网', image: 'subGraph_image', icon: 'subGraph_icon', type: ht.SubGraph },
            { name: '多边形', image: 'shape_icon', stretch: 'uniform', shapeType: ht.Shape, draggable: false },
            { name: '多线段', image: 'polyline_icon', stretch: 'uniform', shapeType: ht.Polyline, draggable: false }
        ]
    },
    edge: {
        name: '连线',
        items: [
            { name: '直线', image: 'images/edge/straight.png', edgeType: null, draggable: false },
            { name: '正交', image: 'images/edge/ortho.png', edgeType: 'ortho2', draggable: false },
            { name: '拐弯', image: 'images/edge/flex.png', edgeType: 'flex2', draggable: false },
            { name: '拐弯', image: 'images/edge/points.png', edgeType: 'points', draggable: false }
        ]        
    },
    icon: {
        name: '图标',
        items: [
            { name: '告警', image: 'alarmIcon', styleIcon: 'alarm' },
            { name: '勾选', image: 'images/icon/check.gif', styleIcon: true },
            { name: '删除', image: 'images/icon/delete.gif', styleIcon: true },
            { name: '刷新', image: 'images/icon/refresh.gif', styleIcon: true },
            { name: '设置', image: 'images/icon/setting.gif', styleIcon: true },
            { name: '未知', image: 'images/icon/unknown.gif', styleIcon: true }            
        ]        
    },
    arrow: {
        name: '箭头',
        items: [
           { name: '起始箭头1',  image: 'sourceArrow1', source: true},
           { name: '终点箭头1',  image: 'targetArrow1', source: false},
           { name: '起始箭头2',  image: 'sourceArrow2', source: true},
           { name: '终点箭头2',  image: 'targetArrow2', source: false}           
        ]        
    }             
};
