data_properties = [
    {
        name: 'id'                        
    },
    {
        name: 'name',
        editable: true                        
    }, 
    {
        name: 'parent'        
    },    
    {       
        categoryName: 'Label',
        name: 'label.color',        
        accessType: 'style',
        valueType: 'color',
        editable: true  
    },  
    {
        categoryName: 'Label',
        name: 'label.background',        
        accessType: 'style',
        valueType: 'color',
        editable: true  
    }, 
    {
        categoryName: 'Label',
        name: 'label.font',        
        accessType: 'style',
        editable: true,
        formatValue: function(value){
            return value || ht.Default.labelFont;
        }
    },
    {
        categoryName: 'Label',
        name: 'label.position',        
        accessType: 'style',
        editable: true,
        slider: {
            min: 1,
            max: 55,
            step: 1
        }        
    },        
    {       
        categoryName: 'Label',
        name: 'label.offset.x',        
        accessType: 'style',
        valueType: 'number',
        editable: true  
    },              
    {       
        categoryName: 'Label',
        name: 'label.offset.y',        
        accessType: 'style',
        valueType: 'number',
        editable: true  
    },    
    {
        categoryName: 'Label',
        name: 'label.rotation',        
        accessType: 'style',
        editable: true,
        slider: {
            min: 0,
            max: Math.PI*2,
            step: Math.PI/180*5,
            getToolTip: function(){
                return Math.round(this.getValue() / Math.PI * 180) + '°';
            }
        }        
    },   
    {
        categoryName: 'Label',
        name: 'label.max',        
        accessType: 'style',
        valueType: 'number',
        editable: true        
    },             
    {
        categoryName: 'Label',
        name: 'label.position.fixed',        
        accessType: 'style',
        valueType: 'boolean',
        editable: true              
    }, 
    {
        categoryName: 'Label',
        name: 'label.opacity',        
        accessType: 'style',
        editable: true,
        slider: {
            min: 0,
            max: 1,
            step: 0.1
        }        
    },             
    {
        categoryName: 'Select',
        name: 'select.color',
        accessType: 'style',
        valueType: 'color',
        editable: true  
    },
    {
        categoryName: 'Select',
        name: 'select.width',
        accessType: 'style',
        valueType: 'number',
        editable: true  
    },
    {
        categoryName: 'Select',
        name: 'select.padding',
        accessType: 'style',
        valueType: 'number',
        editable: true  
    },    
    {
        categoryName: 'Select',
        name: 'select.type',                       
        editable: true,
        accessType: 'style',    
        enum: {
            values: ['rect', 'circle', 'oval', 'roundRect']
        }                     
    },           
    {
        name: 'alarm.color',
        accessType: 'attr',        
        valueType: 'color',
        editable: true
    }
];

node_properties = [
    {
        categoryName: 'Node',
        name: 'host'        
    },
    {
        categoryName: 'Node',
        name: 'image',
        editable: true
    },            
    {
        categoryName: 'Node',
        name: 'position',
        getValue: function(data){
            var position = data.getPosition();
            return 'x: ' + parseInt(position.x) + ', y: ' + parseInt(position.y); 
        }
    },            
    {
        categoryName: 'Node',
        name: 'width',
        valueType: 'number',
        editable: true                        
    }, 
    {
        categoryName: 'Node',
        name: 'height',
        valueType: 'number',
        editable: true                        
    },
    {
        categoryName: 'Node',
        name: 'image.stretch',
        editable: true,
        accessType: 'style',    
        enum: {
            values: ['fill', 'uniform', 'centerUniform']
        }         
    },        
    {
        categoryName: 'Node',
        name: 'rotation',
        valueType: 'number',
        editable: true,
        slider: {
            min: 0,
            max: Math.PI*2,
            getToolTip: function(){
                return Math.round(this.getValue() / Math.PI * 180) + '°';
            }
        }         
    }        
];

group_properties = [
    {
        categoryName: 'Group',
        name: 'expanded',                
        editable: true  
    },
    {
        categoryName: 'Group',
        name: 'group.type',                       
        editable: true,
        accessType: 'style',        
        enum: {
            values: [null, 'oval', 'circle', 'rect', 'roundRect']
        }                        
    },
    {
        categoryName: 'Group',
        name: 'group.image', 
        accessType: 'style', 
        editable: true  
    },            
    {
        categoryName: 'Group',
        name: 'group.image.stretch',
        editable: true,
        accessType: 'style',    
        enum: {
            values: ['fill', 'uniform', 'centerUniform']
        }         
    },            
    {
        categoryName: 'Group',
        name: 'group.padding',                       
        editable: true,
        accessType: 'style',    
        valueType: 'number'                      
    }, 
    {
        categoryName: 'Group',
        name: 'group.padding.top',                       
        editable: true,
        accessType: 'style',    
        valueType: 'number'                      
    },
    {
        categoryName: 'Group',
        name: 'group.padding.bottom',                       
        editable: true,
        accessType: 'style',    
        valueType: 'number'                      
    },            
    {
        categoryName: 'Group',
        name: 'group.padding.left',                       
        editable: true,
        accessType: 'style',    
        valueType: 'number'                      
    }, 
    {
        categoryName: 'Group',
        name: 'group.padding.right',                       
        editable: true,
        accessType: 'style',    
        valueType: 'number'                      
    },              
    {
        categoryName: 'Group',
        name: 'group.depth',                       
        editable: true,
        accessType: 'style',    
        valueType: 'number'                      
    },
    {
        categoryName: 'Group',
        name: 'group.border.pattern',                       
        editable: true,
        accessType: 'style',
        setValue: function(data, property, value, view){
            data.s('group.border.pattern', eval(value));
        },
        formatValue: function(value){
            return '[' + (value || '') + ']';
        }        
    },            
    {
        categoryName: 'Group',
        name: 'group.border.width',                       
        editable: true,
        accessType: 'style',    
        valueType: 'number'                      
    },       
    {
        categoryName: 'Group',
        name: 'group.border.cap',                       
        editable: true,
        accessType: 'style',        
        enum: {
            values: ['butt', 'round', 'square']
        }                        
    },            
    {
        categoryName: 'Group',
        name: 'group.border.join',                       
        editable: true,
        accessType: 'style',        
        enum: {
            values: ['bevel', 'round', 'miter']
        }                        
    },              
    {
        categoryName: 'Group',
        name: 'group.background',                       
        editable: true,
        accessType: 'style',    
        valueType: 'color'                      
    }, 
    {
        categoryName: 'Group',
        name: 'group.gradient',                       
        editable: true,
        accessType: 'style',    
        enum: {
            values: ['linear.southwest','linear.southeast','linear.northwest','linear.northeast',
                'linear.north','linear.south','linear.west','linear.east',
                'radial.center','radial.southwest','radial.southeast','radial.northwest','radial.northeast',
                'radial.north','radial.south','radial.west','radial.east',
                'spread.horizontal','spread.vertical','spread.diagonal','spread.antidiagonal',
                'spread.north','spread.south','spread.west','spread.east']
        }                     
    },            
    {
        categoryName: 'Group',
        name: 'group.gradient.color',                       
        editable: true,
        accessType: 'style',    
        valueType: 'color'                      
    },  
    {
        categoryName: 'Group',
        name: 'group.title.align',                       
        editable: true,
        accessType: 'style',        
        enum: {
            values: ['left', 'center', 'right']
        }                        
    },
    {       
        categoryName: 'Group',
        name: 'group.title.color',        
        accessType: 'style',
        valueType: 'color',
        editable: true  
    },  
    {
        categoryName: 'Group',
        name: 'group.title.background',        
        accessType: 'style',
        valueType: 'color',
        editable: true  
    }, 
    {
        categoryName: 'Group',
        name: 'group.title.font',        
        accessType: 'style',
        editable: true,
        formatValue: function(value){
            return value || ht.Default.labelFont;
        }
    }
];

edge_properties = [
    {
        name: 'edge.width', 
        accessType: 'style',
        valueType: 'number',        
        editable: true  
    },
    {
        name: 'edge.color',
        accessType: 'style',
        valueType: 'color',
        editable: true  
    }            
];

swithc_properties = [
    {
        name: 'switch.angle', 
        accessType: 'style',
        valueType: 'number',        
        editable: true,
        slider: {
            min: -Math.PI/4,
            max: 0,
            step: Math.PI/180,
            getToolTip: function(){
                return Math.round(this.getValue() / Math.PI * 180) + '°';
            }
        }
    },
    {
        name: 'expanded',
        valueType: 'boolean',
        editable: true  
    }              
];